;***************************************;***************************************
;                               		
;    Filename:							LightHouseBeacon                               
;    Date:                        		11/4/2010             
;    File Version:                    	0.1  
;                                         
;    Author:                          	jeff bachiochi    
;    Company:                           imagine that
;										www.imaginethatnow.com  
;                                                        
;***************************************;***************************************
;                                                         
;    Files required: P18F2431.INC  
;
;	NOTES	This is inline code.  It requires more room but executes faster  
;		It is much easier to understand                           
;                                                      
;***************************************;***************************************
;
	LIST P=18F2431, F=INHX32 ;directive to define processor
	#include <P18F2431.INC>	 ;processor specific variable definitions
;
;***************************************;***************************************
;
;	Configuration bits
;                                                        
;***************************************;***************************************
;
;   Oscillator Selection:
;     OSC = LP             LP
;     OSC = XT             XT
;     OSC = HS             HS
;     OSC = RC2            External RC, RA6 is CLKOUT
;     OSC = EC             EC, RA6 is CLKOUT
;     OSC = ECIO           EC, RA6 is I/O
;     OSC = HSPLL          HS-PLL Enabled
;     OSC = RCIO           External RC, RA6 is I/O
	CONFIG	OSC = IRCIO          		; Internal RC, RA6 & RA7 are I/O
;     OSC = IRC            Internal RC, RA6 is CLKOUT, RA7 is I/O
;     OSC = RC1            External RC, RA6 is CLKOUT
;     OSC = RC             External RC, RA6 is CLKOUT
;
;   Fail-Safe Clock Monitor Enable:
;     FCMEN = OFF          Disabled
;     FCMEN = ON           Enabled
;
;   Internal/External Switch-Over:
;     IESO = OFF           Disabled
;     IESO = ON            Enabled
;
;   Power-up Timer:
;     PWRTEN = ON          Enabled
;     PWRTEN = OFF         Disabled
;
;   Brown-out Reset:
;     BOREN = OFF          Disabled
;     BOREN = ON           Enabled
;
;   Brown-out Voltage:
;     BORV = 45            4.5V
;     BORV = 42            4.2V
;     BORV = 27            2.7V
;     BORV = 20            2.0V
;
;   Watchdog Timer:
	CONFIG     WDTEN = OFF          	; Disabled
;     WDTEN = ON           Enabled
;
;   Watchdog Timer Enable Window:
;     WINEN = ON           Enabled
;     WINEN = OFF          Disabled
;
;   Watchdog Postscaler:
;     WDPS = 1             1:1
;     WDPS = 2             1:2
;     WDPS = 4             1:4
;     WDPS = 8             1:8
;     WDPS = 16            1:16
;     WDPS = 32            1:32
;     WDPS = 64            1:64
;     WDPS = 128           1:128
;     WDPS = 256           1:256
;     WDPS = 512           1:512
;     WDPS = 1024          1:1024
;     WDPS = 2048          1:2048
;     WDPS = 4096          1:4096
;     WDPS = 8192          1:8192
;     WDPS = 16384         1:16384
;     WDPS = 32768         1:32768
;
;   Timer1 Oscillator MUX:
;     T1OSCMX = OFF        Active
;     T1OSCMX = ON         Inactive
;
;   High-Side Transistors Polarity:
;     HPOL = LOW           Active low
;     HPOL = HIGH          Active high
;
;   Low-Side Transistors Polarity:
;     LPOL = LOW           Active low
;     LPOL = HIGH          Active high
;
;   PWM output pins Reset state control:
;     PWMPIN = ON          Enabled
;     PWMPIN = OFF         Disabled
;
;   MCLR Enable:
;     MCLRE = OFF          Disabled
;     MCLRE = ON           Enabled
;
;   Stack Overflow Reset:
;     STVREN = OFF         Disabled
;     STVREN = ON          Enabled
;
;   Low Voltage Programming:
;     LVP = OFF            Disabled
;     LVP = ON             Enabled
;
;   Background Debugger Enable:
;     DEBUG = ON           Enabled
;     DEBUG = OFF          Disabled
;
;   Code Protection Block 0:
;     CP0 = ON             Enabled
;     CP0 = OFF            Disabled
;
;   Code Protection Block 1:
;     CP1 = ON             Enabled
;     CP1 = OFF            Disabled
;
;   Code Protection Block 2:
;     CP2 = ON             Enabled
;     CP2 = OFF            Disabled
;
;   Code Protection Block 3:
;     CP3 = ON             Enabled
;     CP3 = OFF            Disabled
;
;   Boot Block Code Protection:
;     CPB = ON             Enabled
;     CPB = OFF            Disabled
;
;   Data EEPROM Code Protection:
;     CPD = ON             Enabled
;     CPD = OFF            Disabled
;
;   Write Protection Block 0:
;     WRT0 = ON            Enabled
;     WRT0 = OFF           Disabled
;
;   Write Protection Block 1:
;     WRT1 = ON            Enabled
;     WRT1 = OFF           Disabled
;
;   Boot Block Write Protection:
;     WRTB = ON            Enabled
;     WRTB = OFF           Disabled
;
;   Configuration Register Write Protection:
;     WRTC = ON            Enabled
;     WRTC = OFF           Disabled
;
;   Data EEPROM Write Protection:
;     WRTD = ON            Enabled
;     WRTD = OFF           Disabled
;
;   Table Read Protection Block 0:
;     EBTR0 = ON           Enabled
;     EBTR0 = OFF          Disabled
;
;   Table Read Protection Block 1:
;     EBTR1 = ON           Enabled
;     EBTR1 = OFF          Disabled
;
;   Boot Block Table Read Protection:
;     EBTRB = ON           Enabled
;     EBTRB = OFF          Disabled
;
;***************************************;***************************************
;
;	Constant definitions
;                                                        
;***************************************;***************************************
;
;	PORTA
LED5	equ		0
LED6	equ		1
LED7	equ		2
LED8	equ		3
;		equ		4
;		equ		5
;		equ		6
;		equ		7
;
;	PORTB
LED1	equ		0
LED2	equ		1
LED3	equ		2
LED4	equ		3
;		equ		4
;		equ		5
;PGD	equ		6
;PGC	equ		7
;
;	PORTC
LED9	equ		0
LED10	equ		1
LED11	equ		2
LED12	equ		3
LED13	equ		4
LED14	equ		5
LED15	equ		6
LED16	equ		7
;
PWMBITS	equ		D'50'
STEPS	equ		D'50'	
;
;***************************************;***************************************
;
;	Variable definitions
;                                                        
;***************************************;***************************************
;
		cblock	0x000
WREG_TEMP								;variable in RAM for context saving 
STATUS_TEMP								;variable in RAM for context saving
BSR_TEMP								;variable in RAM for context saving
;
PWM1
PWM2
PWM3
PWM4
PWM5
PWM6
PWM7
PWM8
PWM9
PWM10
PWM11
PWM12
PWM13
PWM14
PWM15
PWM16
;
FLAGSH
FLAGSL
COUNT
PHASE
TEMP
CYCLE

		endc								
;                                                        
;***************************************;***************************************
;
;	EEPROM data
;                                                        
;***************************************;***************************************
;
;		DE	"Test Data",0,1,2,3,4,5
;                                                        
;***************************************;***************************************
;
;	Reset vector
;                                                        
;***************************************;***************************************
;
	
RESET_VECTOR:		ORG	0x0000

		goto	Init					; go to start of initialization code
;                                                        
;***************************************;***************************************
;
;	High priority interrupt vector
;                                                        
;***************************************;***************************************
;
HI_INT_VECTOR:		ORG	0x0008

		bra	HighInt		;go to high priority interrupt routine
;                                                        
;***************************************;***************************************
;
;	Low priority interrupt vector and routine
;                                                        
;***************************************;***************************************
;
LOW_INT_VECTOR:		ORG	0x0018

		bra	LowInt		;go to low priority interrupt routine
;                                                        
;***************************************;***************************************
;
;	High priority interrupt routine
;                                                        
;***************************************;***************************************
;
HighInt:
		
;	*** high priority interrupt code goes here ***


		retfie	FAST
;                                                        
;***************************************;***************************************
;
;	Low priority interrupt routine
; The low priority interrupt code is placed here.
;                                                        
;***************************************;***************************************
;
LowInt:
		movff	STATUS,STATUS_TEMP	;save STATUS register
		movff	WREG,WREG_TEMP		;save working register
		movff	BSR,BSR_TEMP		;save BSR register

;	*** low priority interrupt code goes here ***


		movff	BSR_TEMP,BSR		;restore BSR register
		movff	WREG_TEMP,WREG		;restore working register
		movff	STATUS_TEMP,STATUS	;restore STATUS register
		retfie
;                                                        
;***************************************;***************************************
;
Init:
Init_OSCCON
		movlw	0x70
		movwf	OSCCON
;		
Init_AD:
		clrf	ANSEL0
;		clrf	ANSEL1
;		
Init_PORTA:
		movlw	b'11110000'				; x, x, x, x, LED8:5=L
		movwf	PORTA
		movlw	b'11110000'				; x, x, x, x, LED8:5=O
		movwf	TRISA		
;
Init_PORTB:
		movlw	b'11110000'				; x, x, x, x, LED4:1=L
		movwf	PORTB
		movlw	b'11110000'				; x, x, x, x, LED4:1=O
		movwf	TRISB
;
Init_PORTC:
		movlw	b'00000000'				; x, x, x, x, LED16:9=L
		movwf	PORTC
		movlw	b'00000000'				; x, x, x, x, LED16:9=O
		movwf	TRISC
;
Init_TMR2:
		movlw	b'01111111'				; x, post=/16, TMR2=EN, pre=/16
		movwf	T2CON
		movlw	D'160'					; 1 ROTATION in x/13 seconds
		movwf	PR2
;
Init_Variables:
		lfsr	0,	0x000
;
Bank0_Loop:		
		clrf	POSTINC0
		tstfsz	FSR0L
		goto	Bank0_Loop	
										
;
		movlw	STEPS
		movwf	PHASE
		movwf	CYCLE	
		
;
		movlw	b'00000001'
		movwf	FLAGSL
		movlw	b'00000000'
		movwf	FLAGSH		
		goto	Main		
;                                                        
;***************************************;***************************************
;
Main:
;                                                    
;***************************************
;
DoPWM1:
		movf	PHASE,	W
		cpfsgt	PWM1					; skip next if PWM's setting>PHASE
		goto	DoPWM1_Off
;
DoPWM1_On:
		bsf		PORTB,	LED1			; turn on PWM's bit in port's value
		goto	DoPWM2
;
DoPWM1_Off:
		bcf		PORTB,	LED1			; turn on PWM's bit in port's value
;
DoPWM2:
		movf	PHASE,	W
		cpfsgt	PWM2					; skip next if PWM's setting>PHASE
		goto	DoPWM2_Off
;
DoPWM2_On:
		bsf		PORTB,	LED2			; turn on PWM's bit in port's value
		goto	DoPWM3
;
DoPWM2_Off:
		bcf		PORTB,	LED2			; turn on PWM's bit in port's value
;
DoPWM3:
		movf	PHASE,	W
		cpfsgt	PWM3					; skip next if PWM's setting>PHASE
		goto	DoPWM3_Off
;
DoPWM3_On:
		bsf		PORTB,	LED3			; turn on PWM's bit in port's value
		goto	DoPWM4
;
DoPWM3_Off:
		bcf		PORTB,	LED3			; turn on PWM's bit in port's value
;
DoPWM4:
		movf	PHASE,	W
		cpfsgt	PWM4					; skip next if PWM's setting>PHASE
		goto	DoPWM4_Off
;
DoPWM4_On:
		bsf		PORTB,	LED4			; turn on PWM's bit in port's value
		goto	DoPWM5
;
DoPWM4_Off:
		bcf		PORTB,	LED4			; turn on PWM's bit in port's value
;
DoPWM5:
		movf	PHASE,	W
		cpfsgt	PWM5					; skip next if PWM's setting>PHASE
		goto	DoPWM5_Off
;
DoPWM5_On:
		bsf		PORTA,	LED5			; turn on PWM's bit in port's value
		goto	DoPWM6
;
DoPWM5_Off:
		bcf		PORTA,	LED5			; turn on PWM's bit in port's value
;
DoPWM6:
		movf	PHASE,	W
		cpfsgt	PWM6					; skip next if PWM's setting>PHASE
		goto	DoPWM6_Off
;
DoPWM6_On:
		bsf		PORTA,	LED6			; turn on PWM's bit in port's value
		goto	DoPWM7
;
DoPWM6_Off:
		bcf		PORTA,	LED6			; turn on PWM's bit in port's value
;
DoPWM7:
		movf	PHASE,	W
		cpfsgt	PWM7					; skip next if PWM's setting>PHASE
		goto	DoPWM7_Off
;
DoPWM7_On:
		bsf		PORTA,	LED7			; turn on PWM's bit in port's value
		goto	DoPWM8
;
DoPWM7_Off:
		bcf		PORTA,	LED7			; turn on PWM's bit in port's value
;
DoPWM8:
		movf	PHASE,	W
		cpfsgt	PWM8					; skip next if PWM's setting>PHASE
		goto	DoPWM8_Off
;
DoPWM8_On:
		bsf		PORTA,	LED8			; turn on PWM's bit in port's value
		goto	DoPWM9
;
DoPWM8_Off:
		bcf		PORTA,	LED8			; turn on PWM's bit in port's value
;
DoPWM9:
		movf	PHASE,	W
		cpfsgt	PWM9					; skip next if PWM's setting>PHASE
		goto	DoPWM9_Off
;
DoPWM9_On:
		bsf		PORTC,	LED9			; turn on PWM's bit in port's value
		goto	DoPWM10
;
DoPWM9_Off:
		bcf		PORTC,	LED9			; turn on PWM's bit in port's value
;
DoPWM10:
		movf	PHASE,	W
		cpfsgt	PWM10					; skip next if PWM's setting>PHASE
		goto	DoPWM10_Off
;
DoPWM10_On:
		bsf		PORTC,	LED10			; turn on PWM's bit in port's value
		goto	DoPWM11
;
DoPWM10_Off:
		bcf		PORTC,	LED10			; turn on PWM's bit in port's value
;
DoPWM11:
		movf	PHASE,	W
		cpfsgt	PWM11					; skip next if PWM's setting>PHASE
		goto	DoPWM11_Off
;
DoPWM11_On:
		bsf		PORTC,	LED11			; turn on PWM's bit in port's value
		goto	DoPWM12
;
DoPWM11_Off:
		bcf		PORTC,	LED11			; turn on PWM's bit in port's value
;
DoPWM12:
		movf	PHASE,	W
		cpfsgt	PWM12					; skip next if PWM's setting>PHASE
		goto	DoPWM12_Off
;
DoPWM12_On:
		bsf		PORTC,	LED12			; turn on PWM's bit in port's value
		goto	DoPWM13
;
DoPWM12_Off:
		bcf		PORTC,	LED12			; turn on PWM's bit in port's value
;
DoPWM13:
		movf	PHASE,	W
		cpfsgt	PWM13					; skip next if PWM's setting>PHASE
		goto	DoPWM13_Off
;
DoPWM13_On:
		bsf		PORTC,	LED13			; turn on PWM's bit in port's value
		goto	DoPWM14
;
DoPWM13_Off:
		bcf		PORTC,	LED13			; turn on PWM's bit in port's value
;
DoPWM14:
		movf	PHASE,	W
		cpfsgt	PWM14					; skip next if PWM's setting>PHASE
		goto	DoPWM14_Off
;
DoPWM14_On:
		bsf		PORTC,	LED14			; turn on PWM's bit in port's value
		goto	DoPWM15
;
DoPWM14_Off:
		bcf		PORTC,	LED14			; turn on PWM's bit in port's value
;
DoPWM15:
		movf	PHASE,	W
		cpfsgt	PWM15					; skip next if PWM's setting>PHASE
		goto	DoPWM15_Off
;
DoPWM15_On:
		bsf		PORTC,	LED15			; turn on PWM's bit in port's value
		goto	DoPWM16
;
DoPWM15_Off:
		bcf		PORTC,	LED15			; turn on PWM's bit in port's value
;
DoPWM16:
		movf	PHASE,	W
		cpfsgt	PWM16					; skip next if PWM's setting>PHASE
		goto	DoPWM16_Off
;
DoPWM16_On:
		bsf		PORTC,	LED16			; turn on PWM's bit in port's value
		goto	DoPWM_Exit
;
DoPWM16_Off:
		bcf		PORTC,	LED16			; turn on PWM's bit in port's value
;
DoPWM_Exit:
;                                                        
;***************************************
;
		decfsz	PHASE,	F				; skip next when PHASE=0 (every STEP times)
		goto	Main_Exit	
;                                                        
;***************************************
;
		movlw	PWMBITS
		movwf	PHASE
		btfss	PIR1,	TMR2IF			; skip next if Timer 0 has overflowed
		goto	Main_Exit
;
		bcf		PIR1,	TMR2IF			; clear timer 0 interrupt		
;                                                        
;***************************************
;		
Ramp:
Ramp1:
		btfss	FLAGSL,	0				; skip next if FLAGSL.0=1
		goto	Ramp1_Dec
;
Ramp1_Inc:
		incf	PWM1,	W
		tstfsz	WREG
		incf	PWM1,	F				; increment only if PWM not 0xFF
		goto	Ramp2		
;
Ramp1_Dec:
		tstfsz	PWM1
		decf	PWM1,	F				; decrement only if PWM not 0x00
		nop	
;		
Ramp2:
		btfss	FLAGSL,	1				; skip next if FLAGSL.1=1
		goto	Ramp2_Dec
;
Ramp2_Inc:
		incf	PWM2,	W
		tstfsz	WREG
		incf	PWM2,	F				; increment only if PWM not 0xFF
		goto	Ramp3		
;
Ramp2_Dec:
		tstfsz	PWM2
		decf	PWM2,	F				; decrement only if PWM not 0x00
		nop	
;
Ramp3:
		btfss	FLAGSL,	2				; skip next if FLAGSL.2=1
		goto	Ramp3_Dec
;
Ramp3_Inc:
		incf	PWM3,	W
		tstfsz	WREG
		incf	PWM3,	F				; increment only if PWM not 0xFF
		goto	Ramp4		
;
Ramp3_Dec:
		tstfsz	PWM3
		decf	PWM3,	F				; decrement only if PWM not 0x00
		nop	
;		
Ramp4:
		btfss	FLAGSL,	3				; skip next if FLAGSL.3=1
		goto	Ramp4_Dec
;
Ramp4_Inc:
		incf	PWM4,	W
		tstfsz	WREG
		incf	PWM4,	F				; increment only if PWM not 0xFF
		goto	Ramp5		
;
Ramp4_Dec:
		tstfsz	PWM4
		decf	PWM4,	F				; decrement only if PWM not 0x00
		nop	
;
Ramp5:
		btfss	FLAGSL,	4				; skip next if FLAGSL.4=1
		goto	Ramp5_Dec
;
Ramp5_Inc:
		incf	PWM5,	W
		tstfsz	WREG
		incf	PWM5,	F				; increment only if PWM not 0xFF
		goto	Ramp6		
;
Ramp5_Dec:
		tstfsz	PWM5
		decf	PWM5,	F				; decrement only if PWM not 0x00
		nop	
;		
Ramp6:
		btfss	FLAGSL,	5				; skip next if FLAGSL.5=1
		goto	Ramp6_Dec
;
Ramp6_Inc:
		incf	PWM6,	W
		tstfsz	WREG
		incf	PWM6,	F				; increment only if PWM not 0xFF
		goto	Ramp7		
;
Ramp6_Dec:
		tstfsz	PWM6
		decf	PWM6,	F				; decrement only if PWM not 0x00
		nop	
;
Ramp7:
		btfss	FLAGSL,	6				; skip next if FLAGSL.6=1
		goto	Ramp7_Dec
;
Ramp7_Inc:
		incf	PWM7,	W
		tstfsz	WREG
		incf	PWM7,	F				; increment only if PWM not 0xFF
		goto	Ramp8		
;
Ramp7_Dec:
		tstfsz	PWM7
		decf	PWM7,	F				; decrement only if PWM not 0x00
		nop	
;		
Ramp8:
		btfss	FLAGSL,	7				; skip next if FLAGSL.7=1
		goto	Ramp8_Dec
;
Ramp8_Inc:
		incf	PWM8,	W
		tstfsz	WREG
		incf	PWM8,	F				; increment only if PWM not 0xFF
		goto	Ramp9		
;
Ramp8_Dec:
		tstfsz	PWM8
		decf	PWM8,	F				; decrement only if PWM not 0x00
		nop	
;
Ramp9:
		btfss	FLAGSH,	0				; skip next if FLAGSH.0=1
		goto	Ramp9_Dec
;
Ramp9_Inc:
		incf	PWM9,	W
		tstfsz	WREG
		incf	PWM9,	F				; increment only if PWM not 0xFF
		goto	Ramp10		
;
Ramp9_Dec:
		tstfsz	PWM9
		decf	PWM9,	F				; decrement only if PWM not 0x00
		nop	
;		
Ramp10:
		btfss	FLAGSH,	1				; skip next if FLAGSH.1=1
		goto	Ramp10_Dec
;
Ramp10_Inc:
		incf	PWM10,	W
		tstfsz	WREG
		incf	PWM10,	F				; increment only if PWM not 0xFF
		goto	Ramp11		
;
Ramp10_Dec:
		tstfsz	PWM10
		decf	PWM10,	F				; decrement only if PWM not 0x00
		nop	
;
Ramp11:
		btfss	FLAGSH,	2				; skip next if FLAGSH.2=1
		goto	Ramp11_Dec
;
Ramp11_Inc:
		incf	PWM11,	W
		tstfsz	WREG
		incf	PWM11,	F				; increment only if PWM not 0xFF
		goto	Ramp12		
;
Ramp11_Dec:
		tstfsz	PWM11
		decf	PWM11,	F				; decrement only if PWM not 0x00
		nop	
;		
Ramp12:
		btfss	FLAGSH,	3				; skip next if FLAGSH.3=1
		goto	Ramp12_Dec
;
Ramp12_Inc:
		incf	PWM12,	W
		tstfsz	WREG
		incf	PWM12,	F				; increment only if PWM not 0xFF
		goto	Ramp13		
;
Ramp12_Dec:
		tstfsz	PWM12
		decf	PWM12,	F				; decrement only if PWM not 0x00
		nop	
;
Ramp13:
		btfss	FLAGSH,	4				; skip next if FLAGSH.4=1
		goto	Ramp13_Dec
;
Ramp13_Inc:
		incf	PWM13,	W
		tstfsz	WREG
		incf	PWM13,	F				; increment only if PWM not 0xFF
		goto	Ramp14		
;
Ramp13_Dec:
		tstfsz	PWM13
		decf	PWM13,	F				; decrement only if PWM not 0x00
		nop	
;		
Ramp14:
		btfss	FLAGSH,	5				; skip next if FLAGSH.5=1
		goto	Ramp14_Dec
;
Ramp14_Inc:
		incf	PWM14,	W
		tstfsz	WREG
		incf	PWM14,	F				; increment only if PWM not 0xFF
		goto	Ramp15		
;
Ramp14_Dec:
		tstfsz	PWM14
		decf	PWM14,	F				; decrement only if PWM not 0x00
		nop	
;
Ramp15:
		btfss	FLAGSH,	6				; skip next if FLAGSH.6=1
		goto	Ramp15_Dec
;
Ramp15_Inc:
		incf	PWM15,	W
		tstfsz	WREG
		incf	PWM15,	F				; increment only if PWM not 0xFF
		goto	Ramp16		
;
Ramp15_Dec:
		tstfsz	PWM15
		decf	PWM15,	F				; decrement only if PWM not 0x00
		nop	
;		
Ramp16:
		btfss	FLAGSH,	7				; skip next if FLAGSH.7=1
		goto	Ramp16_Dec
;
Ramp16_Inc:
		incf	PWM16,	W
		tstfsz	WREG
		incf	PWM16,	F				; increment only if PWM not 0xFF
		goto	Ramp_Exit		
;
Ramp16_Dec:
		tstfsz	PWM16
		decf	PWM16,	F				; decrement only if PWM not 0x00
		nop	
;
Ramp_Exit:
;                                                        
;***************************************
;	
		decfsz	CYCLE,	F				; skip next when CYCLE=0 (every STEP times)
		goto	Main_Exit
;                                                        
;***************************************
;
		movlw	STEPS
		movwf	CYCLE				
		rlcf	FLAGSH,	W
		rlcf	FLAGSL,	F
		rlcf	FLAGSH,	F
;                                                        
;***************************************
;
Main_Exit:	
		goto	Main	
;                                                        
;***************************************;***************************************
;
;	End of program
;                                                        
;***************************************;***************************************
;
		END
