/* ----------------------------------------------------------
		
		Psychedelic led lights with dsPic 30F2020 
		Marco Signorini - marco.signorini@libero.it
		
		File: inbuffer.h
	-----------------------------------------------------------
*/

#ifndef _INBUFFER_H_
#define _INBUFFER_H_

#include <dsp.h>

/* Initialize the buffer */
void INBUF_Init(void);

/* Add a new sample into the queue */
void INBUF_AddSample(unsigned int uiSample);

/* Check the valid buffer size */
unsigned char INBUF_GetFilledSize(void);

/* Retrieve current buffer head */
fractional* INBUF_GetBuffer(void);

/* Release the buffer already evaluated */
void INBUF_Release(void);

#endif /* _INBUFFER_H_ */

