; ..............................................................................
;    File   iirbandpass.s
; ..............................................................................

		.equ iirbandpassNumSections, 4

; ..............................................................................
;
; Allocate and initialize filter coefficients
;
; These coefficients have been designed for use in the Transpose filter only

		.section .iirbandpassconst, code ;

iirbandpassCoefs:
.hword	0x0922	; b( 1,0)/2
.hword	0x0D42	; b( 1,1)/2
.hword	0x31B4	; a( 1,1)/2
.hword	0x0922	; b( 1,2)/2
.hword	0xDB42	; a( 1,2)/2
.hword	0x2D5B	; b( 2,0)/2
.hword	0xA5D1	; b( 2,1)/2
.hword	0x650B	; a( 2,1)/2
.hword	0x2D5B	; b( 2,2)/2
.hword	0xCF6F	; a( 2,2)/2
.hword	0x1F56	; b( 3,0)/2
.hword	0x0CD4	; b( 3,1)/2
.hword	0x12FB	; a( 3,1)/2
.hword	0x1F56	; b( 3,2)/2
.hword	0xC88E	; a( 3,2)/2
.hword	0x3C95	; b( 4,0)/2
.hword	0x89B9	; b( 4,1)/2
.hword	0x7707	; a( 4,1)/2
.hword	0x3C95	; b( 4,2)/2
.hword	0xC2D0	; a( 4,2)/2

; ..............................................................................
; Allocate states buffers in (uninitialized) Y data space

		.section .ydata, data, ymemory

iirbandpassStates1:
		.space iirbandpassNumSections*2

iirbandpassStates2:
		.space iirbandpassNumSections*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _iirbandpassFilter

_iirbandpassFilter:
.hword iirbandpassNumSections-1
.hword psvoffset(iirbandpassCoefs)
.hword psvpage(iirbandpassCoefs)
.hword iirbandpassStates1
.hword iirbandpassStates2
.hword 0x0000

; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_IIRTransposeFilterInit
;		.extern	_BlockIIRTransposeFilter
;		.extern	_iirbandpassFilter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 4)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_iirbandpassFilter, W0	; Initalize W0 to filter structure
;		call	_IIRTransposeFilterInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _BlockIIRTransposeFilter
;		mov	#_iirbandpassFilter, W0	; Initalize W0 to filter structure
;		mov	#input, W1	; Initalize W1 to input buffer 
;		mov	#output, W2	; Initalize W2 to output buffer
;		mov	#20, W3	; Initialize W3 with number of required output samples
;		call	_BlockIIRTransposeFilter	; call as many times as needed
