; ..............................................................................
;    File   iirlowpass.s
; ..............................................................................

		.equ iirlowpassNumSections, 2

; ..............................................................................
;
; Allocate and initialize filter coefficients
;
; These coefficients have been designed for use in the Transpose filter only

		.section .iirlowpassconst, code ;

iirlowpassCoefs:
.hword	0x00E2	; b( 1,0)/2
.hword	0xFEB4	; b( 1,1)/2
.hword	0x78D4	; a( 1,1)/2
.hword	0x00E2	; b( 1,2)/2
.hword	0xC6B1	; a( 1,2)/2
.hword	0x0C82	; b( 2,0)/2
.hword	0xE862	; b( 2,1)/2
.hword	0x7C12	; a( 2,1)/2
.hword	0x0C82	; b( 2,2)/2
.hword	0xC265	; a( 2,2)/2

; ..............................................................................
; Allocate states buffers in (uninitialized) Y data space

		.section .ydata, data, ymemory

iirlowpassStates1:
		.space iirlowpassNumSections*2

iirlowpassStates2:
		.space iirlowpassNumSections*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _iirlowpassFilter

_iirlowpassFilter:
.hword iirlowpassNumSections-1
.hword psvoffset(iirlowpassCoefs)
.hword psvpage(iirlowpassCoefs)
.hword iirlowpassStates1
.hword iirlowpassStates2
.hword 0x0000

; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_IIRTransposeFilterInit
;		.extern	_BlockIIRTransposeFilter
;		.extern	_iirlowpassFilter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 4)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_iirlowpassFilter, W0	; Initalize W0 to filter structure
;		call	_IIRTransposeFilterInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _BlockIIRTransposeFilter
;		mov	#_iirlowpassFilter, W0	; Initalize W0 to filter structure
;		mov	#input, W1	; Initalize W1 to input buffer 
;		mov	#output, W2	; Initalize W2 to output buffer
;		mov	#20, W3	; Initialize W3 with number of required output samples
;		call	_BlockIIRTransposeFilter	; call as many times as needed
