/* ----------------------------------------------------------
		
		Psychedelic led lights with dsPic 30F2020 
		Marco Signorini - marco.signorini@libero.it
		
		File: PsyLightConsoleDlg.c
	-----------------------------------------------------------
*/

#include "stdafx.h"
#include "PsyLightConsole.h"
#include "PsyLightConsoleDlg.h"
#include "atlbase.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define FLOAT_RENDER_STRING		"%.5f"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPsyLightConsoleDlg dialog

CPsyLightConsoleDlg::CPsyLightConsoleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPsyLightConsoleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPsyLightConsoleDlg)
	m_ucLowEdit = _T("");
	m_ucMidEdit = _T("");
	m_ucHiEdit = _T("");
	m_csInPower = _T("");
	m_csLowPower = _T("");
	m_csMidPower = _T("");
	m_csHighPower = _T("");
	m_ucPowerScoreEdit = _T("");
	m_csPowerFactorEdit = _T("");
	m_csPowerClippedSamples = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPsyLightConsoleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPsyLightConsoleDlg)
	DDX_Control(pDX, IDC_HI_PROGRESS, m_cHighProgress);
	DDX_Control(pDX, IDC_MID_PROGRESS, m_cMidProgress);
	DDX_Control(pDX, IDC_LOW_PROGRESS, m_cLowProgress);
	DDX_Control(pDX, IDC_UNCONNECT, m_cbUnconnect);
	DDX_Control(pDX, IDC_CONNECT, m_cbConnect);
	DDX_Control(pDX, IDC_COMPORT, m_cbComPort);
	DDX_Control(pDX, IDC_MSCOMM1, m_cCOMPort);
	DDX_Text(pDX, IDC_UCLOW_EDIT, m_ucLowEdit);
	DDX_Text(pDX, IDC_UCMID_EDIT, m_ucMidEdit);
	DDX_Text(pDX, IDC_UCHI_EDIT, m_ucHiEdit);
	DDX_Text(pDX, IDC_IN_POWER, m_csInPower);
	DDX_Text(pDX, IDC_LOW_POWER, m_csLowPower);
	DDX_Text(pDX, IDC_MID_POWER, m_csMidPower);
	DDX_Text(pDX, IDC_HI_POWER, m_csHighPower);
	DDX_Text(pDX, IDC_UCPWSCORE_EDIT, m_ucPowerScoreEdit);
	DDX_Text(pDX, IDC_UCPWFACTOR_EDIT, m_csPowerFactorEdit);
	DDX_Text(pDX, IDC_UCPWCLIPSMPS_EDIT, m_csPowerClippedSamples);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPsyLightConsoleDlg, CDialog)
	//{{AFX_MSG_MAP(CPsyLightConsoleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_UNCONNECT, OnUnconnect)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_EVENTSINK_MAP(CPsyLightConsoleDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CPsyLightConsoleDlg)
	ON_EVENT(CPsyLightConsoleDlg, IDC_MSCOMM1, 1 /* OnComm */, OnCOMEvent, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPsyLightConsoleDlg message handlers

BOOL CPsyLightConsoleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Gain strings
	m_acsGains[0] = TEXT("1dB");
	m_acsGains[1] = TEXT("2dB");
	m_acsGains[2] = TEXT("4dB");
	m_acsGains[3] = TEXT("5dB");
	m_acsGains[4] = TEXT("8dB");
	m_acsGains[5] = TEXT("10dB");
	m_acsGains[6] = TEXT("16dB");
	m_acsGains[7] = TEXT("32dB");
	
	// Custom initializations
	m_cbComPort.SetCurSel(0);
	m_cbUnconnect.EnableWindow(FALSE);

	m_ucLowEdit = TEXT("0");
	m_ucMidEdit = TEXT("0");
	m_ucHiEdit = TEXT("0");
	
	m_ucPowerScoreEdit = TEXT("128");
	m_csPowerFactorEdit = m_acsGains[0];
	m_csPowerClippedSamples = TEXT("0");

	m_cLowProgress.SetRange(0,31);
	m_cMidProgress.SetRange(0,31);
	m_cHighProgress.SetRange(0,31);
	m_cLowProgress.SetPos(0);
	m_cMidProgress.SetPos(0);
	m_cHighProgress.SetPos(0);

	m_csInPower.Format(FLOAT_RENDER_STRING,0.0);
	m_csLowPower.Format(FLOAT_RENDER_STRING,0.0);
	m_csMidPower.Format(FLOAT_RENDER_STRING,0.0);
	m_csHighPower.Format(FLOAT_RENDER_STRING,0.0);

	m_uiTimerHandler = 0;
	m_BufferedLowVal = 0;
	m_BufferedMidVal = 0;
	m_BufferedHiVal = 0;

	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// ----------------------------------------------------------------------------------

void CPsyLightConsoleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ----------------------------------------------------------------------------------

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPsyLightConsoleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ----------------------------------------------------------------------------------

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPsyLightConsoleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// ----------------------------------------------------------------------------------

// Connect with selected serial port
void CPsyLightConsoleDlg::OnConnect() 
{
	// Open the COM port
	m_cCOMPort.SetInBufferCount(0);
	m_cCOMPort.SetCommPort(m_cbComPort.GetCurSel()+1);
	m_cCOMPort.SetSettings("115200,n,8,1");

	// Open the selected port
	m_ucPacketOffset = 0;
	m_bValidPacket = false;
	m_cCOMPort.SetPortOpen(TRUE);

	// Enable other buttons
	m_cbConnect.EnableWindow(FALSE);
	m_cbUnconnect.EnableWindow(TRUE);

	// Generate a new Timer
	m_uiTimerHandler = SetTimer(0x8000, 250, NULL);
}

// ----------------------------------------------------------------------------------

// Unconnect serial port
void CPsyLightConsoleDlg::OnUnconnect() 
{
	// Close the COM port
	m_cCOMPort.SetPortOpen(FALSE);

	m_cbConnect.EnableWindow(TRUE);
	m_cbUnconnect.EnableWindow(FALSE);

	KillTimer(m_uiTimerHandler);
}

// ----------------------------------------------------------------------------------


// On data received from RS232, update the dialog
void CPsyLightConsoleDlg::OnCOMEvent() 
{
	CComVariant vIn;
	CString csIn;

	short sCommEvent = m_cCOMPort.GetCommEvent();
	if (sCommEvent != 2)
		return;

	// Read the data from the extenal device
	short sInputLength = m_cCOMPort.GetInBufferCount();

	vIn = m_cCOMPort.GetInput();
	csIn = vIn.bstrVal;

	short shOffset = -1;
	while (sInputLength)
	{
		sInputLength--;
		shOffset++;

		unsigned char ucValue = *(((unsigned char*)(vIn.parray->pvData))+shOffset);

		// Parse incoming data
		if ((ucValue == '#') && (!m_bValidPacket))
		{
			// This is the start packet
			m_ucPacketOffset = 0;
			m_bValidPacket = true;

			// clear all previous received data
			memset((void*) &m_sInDataPacket, 0, sizeof(incomingdata));

			continue;
		}

		// Start packet already found. 
		// Fill packet buffer
		if (m_bValidPacket && (m_ucPacketOffset <= sizeof(incomingdata)))
		{
			((unsigned char*)&m_sInDataPacket)[m_ucPacketOffset] = ucValue;
			m_ucPacketOffset++;
		}

		// End of packet reached, process data
		if ((ucValue == '@') && m_bValidPacket && (m_ucPacketOffset == (sizeof(incomingdata)+1)))
		{
			// Format in a readable way
			m_csInPower.Format(FLOAT_RENDER_STRING,FractionalToFloat(m_sInDataPacket.ushInPower));
			m_csLowPower.Format(FLOAT_RENDER_STRING,FractionalToFloat(m_sInDataPacket.ushLowPower));
			m_csMidPower.Format(FLOAT_RENDER_STRING,FractionalToFloat(m_sInDataPacket.ushMidPower));
			m_csHighPower.Format(FLOAT_RENDER_STRING,FractionalToFloat(m_sInDataPacket.ushHiPower));

			m_ucLowEdit.Format("%d", m_sInDataPacket.ucLowVal);
			m_ucMidEdit.Format("%d", m_sInDataPacket.ucMidVal);
			m_ucHiEdit.Format("%d", m_sInDataPacket.ucHiVal);
			
			m_ucPowerScoreEdit.Format("%d", m_sInDataPacket.ucPowerScore);
			m_csPowerFactorEdit = m_acsGains[m_sInDataPacket.ucPowerFactor & 0x07];
			m_csPowerClippedSamples.Format("%d", m_sInDataPacket.ucPowerClippedSamples);

			m_BufferedLowVal = m_sInDataPacket.ucLowVal;
			m_BufferedMidVal = m_sInDataPacket.ucMidVal;
			m_BufferedHiVal = m_sInDataPacket.ucHiVal;

			// Invalidate the packet
			m_bValidPacket = false;
		}
	}
}

// ----------------------------------------------------------------------------------

// Convert dsPIC Fractional format to Intel float format
float CPsyLightConsoleDlg::FractionalToFloat(unsigned short shFractional)
{
	float fValue = 0.0;

	// Reverse byte order
	// unsigned short i386Fractional = ((shFractional & 0xFF)<<16) | ((shFractional & 0xFF00)>>16);
	unsigned short i386Fractional = shFractional;

	// Take the sign
	bool bNegative = (i386Fractional & 0x8000)?true:false;

	// Calculate Q15 absolute value
	i386Fractional &= 0x7FFF;

	// Calculate float absolute value
	fValue = (float) (pow(2.0,-15.0)*((double)i386Fractional));

	// Apply sign
	fValue = fValue * ((bNegative)? -1 : 1);

	return fValue;
}

// ----------------------------------------------------------------------------------

// Update the dialog at every timer tick
void CPsyLightConsoleDlg::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent == 0x8000)
	{
		m_cLowProgress.SetPos(m_BufferedLowVal);
		m_cMidProgress.SetPos(m_BufferedMidVal);
		m_cHighProgress.SetPos(m_BufferedHiVal);

		UpdateData(FALSE);
	}
	
	CDialog::OnTimer(nIDEvent);
}
