/* ----------------------------------------------------------
		
		Psychedelic led lights with dsPic 30F2020 
		Marco Signorini - marco.signorini@libero.it
		
		File: PsyLightConsoleDlg.h
	-----------------------------------------------------------
*/

//
//{{AFX_INCLUDES()
#include "mscomm.h"
//}}AFX_INCLUDES

#if !defined(AFX_PSYLIGHTCONSOLEDLG_H__52F6B1CF_058C_4C09_BABC_3F0A39064840__INCLUDED_)
#define AFX_PSYLIGHTCONSOLEDLG_H__52F6B1CF_058C_4C09_BABC_3F0A39064840__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CPsyLightConsoleDlg dialog

class CPsyLightConsoleDlg : public CDialog
{
// Construction
public:
	CPsyLightConsoleDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CPsyLightConsoleDlg)
	enum { IDD = IDD_PSYLIGHTCONSOLE_DIALOG };
	CProgressCtrl	m_cHighProgress;
	CProgressCtrl	m_cMidProgress;
	CProgressCtrl	m_cLowProgress;
	CButton	m_cbUnconnect;
	CButton	m_cbConnect;
	CComboBox	m_cbComPort;
	CMSComm	m_cCOMPort;
	CString	m_ucLowEdit;
	CString	m_ucMidEdit;
	CString	m_ucHiEdit;
	CString	m_csInPower;
	CString	m_csLowPower;
	CString	m_csMidPower;
	CString	m_csHighPower;
	CString	m_ucPowerScoreEdit;
	CString	m_csPowerFactorEdit;
	CString	m_csPowerClippedSamples;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPsyLightConsoleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CPsyLightConsoleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnConnect();
	afx_msg void OnUnconnect();
	afx_msg void OnCOMEvent();
	afx_msg void OnTimer(UINT nIDEvent);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	float FractionalToFloat(unsigned short shFractional);

private:
	typedef struct _incomingdata
	{
		unsigned short	ushInPower;
		unsigned char		ucPowerClippedSamples;
		unsigned short	ushLowPower;
		unsigned char		ucLowVal;
		unsigned short	ushMidPower;
		unsigned char		ucMidVal;
		unsigned short	ushHiPower;
		unsigned char		ucHiVal;
		unsigned char		ucPowerScore;
		unsigned char		ucPowerFactor;
	} incomingdata;

private:
	unsigned char		m_ucPacketOffset;
	bool						m_bValidPacket;
	incomingdata		m_sInDataPacket;
	UINT						m_uiTimerHandler;
	unsigned char		m_BufferedLowVal;
	unsigned char		m_BufferedMidVal;
	unsigned char		m_BufferedHiVal;
	CString					m_acsGains[8];
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PSYLIGHTCONSOLEDLG_H__52F6B1CF_058C_4C09_BABC_3F0A39064840__INCLUDED_)
